<?php
include("./conf/meta.php");
include("./conf/conf.inc.php");
include("./functions.php");

if (check_mac($mac) && check_ip($ip) && check_hostname($hostname))
{
    $is_uniq=true;
    $file_array = file($ThinConf);
    if(!$file_array)
    {
        echo("Cannot open file \"".$ThinConf."\".<br>");
    }
    else
    {

	for($i=0; $i < count($file_array); $i++)
	{
		$strings[$i]=$file_array[$i];   
    		$d_pos=strpos($file_array[$i], "#");
		$strln=strlen($file_array[$i]);
		if (strlen(trim($file_array[$i]))>0)
		    if ($d_pos)
			{	
				$len_real=$d_pos;
			}
			else
			{
				if ($file_array[$i][0]=="#")
					$len_real=0;
				else
				    {
					$len_real=$strln;
				    }
			} 
		    if ($len_real)
		    {	
			$string_real = str_replace(" ","\t",substr($file_array[$i],0,$len_real));
			$string_real = str_replace("\t\t","\t",$string_real);
			$params=explode("\t",$string_real,3);
			$hostname_check=trim($params[0]);
			$mac_check=trim($params[1]);
			if($hostname_check==$hostname)
			    {
				$is_uniq=false;
			    }
			if($mac_check==str_replace(":","",$mac))
			    {
				$is_uniq=false;
			    }
		    }
	}



if ($is_uniq)
{
    $stringn=$hostname."\t".str_replace(":","",$mac)."\t".$resol."\t".$client."\t";
    for ($g=0;$g<sizeof($GROUPS_CHECKED);$g++)
    $stringn=$stringn.$GROUPS_CHECKED[$g]."\t";
    $stringn=$stringn."# ".stripslashes($descr)."\n";//." ## ".$ip."\n";

    $strings[sizeof($strings)]=$stringn;
// .
    $conf_file=fopen($ThinConf,"w+");
    for($i=0; $i < count($strings); $i++)
    {
	fwrite($conf_file,$strings[$i]);
    }
    fclose($conf_file);


/// DHCP
$dhcparray=file($DHCPD_CONF);
if(!$dhcparray)
{
    echo "Cannot open ".$DHCPD_CONF."<br>";
}
else
{


$str_d[0]="\n\n# ".$descr."\n";
$str_d[1]=" host ".$hostname." {\n";
$str_d[2]="\thardware ethernet ".$mac.";\n";
$str_d[3]="\tfixed-address\t".$ip.";\n";
$str_d[4]="\tnext-server\t".$DHCP_NEXT_SERVER.";\n";
$str_d[5]="\tfilename\t\"".$DHCP_FILENAME."\";\n";
$str_d[6]="}\n";
$str_d[7]="}\n";

$d=sizeof($dhcparray);
$end=sizeof($dhcparray)-1;
while(!strstr($dhcparray[$d],"}") )
	{ 
	$d--;
	}
for($t=0;$t<sizeof($str_d);$t++)
    $dhcparray[$end+$t]=$str_d[$t];
$dhcp_file=fopen($DHCPD_CONF,"w+");
    for($i=0; $i < count($dhcparray); $i++)
    {
	fwrite($dhcp_file,$dhcparray[$i]);
    }
    fclose($dhcp_file);
}


echo "<form method=post action=\"./dhcp-restart.php\">
                    <input type=submit target=_blank value=\"  DHCP\" style=font-size:9pt;>
		                    </form>";



}//end of if ($is_uniq)
else
    echo "PARAMETERS FOR TERMINAL IS NOT UNIQ. CHECK IT PLEASE.";
}//end of fileopen
}//end of checks
else
    {
	echo "Wrong Parameters:<br>";
	if(!check_hostname($hostname))echo "<font color=red>HOSTNAME: ".$hostname."</font><br>";else  echo "<font color=green>HOSTNAME: ".$hostname." OK</font><br>";
	if(!check_mac($mac))echo "<font color=red>MAC-ADDR: ".$mac."</font><br>"; else echo "<font color=green>MAC-ADDR: ".$mac." OK</font><br>";
	if(!check_ip($ip))echo "<font color=red>IP-ADDR: .".$ip."</font><br>"; else echo "<font color=green>IP-ADDR: .".$ip." OK</font><br>";
}

?>